/*//////////   SCRIPT:   displaceMgr v1.0   //////////*/
/*//////////   WRITTEN BY:   Branko Zivkovic   //////////*/
/*//////////   EMAIL:   barigazy@hotmail.com   //////////*/
struct mng_ui 
(
	fn defColor r g b = ((dotNetClass "System.Drawing.Color").FromArgb r g b),
	fn defLabel ctrl txt: bc: fc: align:#left size:8 =
	(
		ctrl.TextAlign = case align of
		(
			#left: ctrl.TextAlign.MiddleLeft
			#right: ctrl.TextAlign.MiddleRight
		)
		ctrl.BackColor = bc ; ctrl.ForeColor = fc ; ctrl.Text = txt
		ctrl.Font = dotNetObject "System.Drawing.Font" "Tahoma" size ((dotNetClass "System.Drawing.FontStyle").regular)
	)	
)
global mngUI = mng_ui ()

try(destroyDialog ::dmdRoll)catch()
try(destroyDialog ::dmoRoll)catch()
try(destroyDialog ::displaceMgr)catch()

rollout displaceMgr "displaceMgr v1.0"
(
	local dspl_obj
	fn filtObj obj = isKindOf obj GeometryClass and canConvertTo obj Editable_Poly
	fn filtBmp tex = isKindOf tex Bitmaptexture and doesfileexist tex.filename
	fn setRenderer rnd =
	(
		installed = off
		local maxRenderers = for re in RendererClass.classes where (matchPattern (re as string) pattern:rnd) collect re
		if maxRenderers.count != 0 do
		(
			if renderers.current as string != maxRenderers[1] as string do renderers.current = maxRenderers[1]()
			installed = on
		)
		installed
	)
	fn breakUnwraper obj mapChannel: =
	(
		if getCommandPanelTaskMode() != #create do setCommandPanelTaskMode #create
		with redraw off
		(
			addmodifier obj (unwrap_uvw ())
			mody = obj.modifiers[#unwrap_uvw]
			mody.setMapChannel mapChannel
			mody.selectVerticesByNode #{1..(mody.NumberVertices())} obj
			mody.breakSelected()
			mody.selectVerticesByNode #{} obj
		)
	)
	fn getPxValue bmptex = 
	(
		gc() ; freeSceneBitmaps()
		local minPixVal = 0, maxPixVal = 0
		for h = 1 to bmptex.height do 
		(
			pixel_line = getpixels bmptex [0,(h-1)] bmptex.width
			for p = 1 to pixel_line.count do
			(
				pxr = pixel_line[p].r
				case of
				(
					(pxr < minPixVal): minPixVal = pxr
					(pxr > maxPixVal): maxPixVal = pxr
				)
			)
		)
		[minPixVal/255., maxPixVal/255.]
	)
	fn makeVDMap vdmap slot: =
	(
		local vrClr121 = VRayColor name:"Clr121" color:white green:2 rgb_multiplier:1 alpha:1 gamma_correction:0 gamma_value:2.2
		local vrComp = VRayCompTex name:"multiply" sourceA:vdmap sourceB:vrClr121 Operator:3
		local vrClr111 = VRayColor name:"Clr111" color:white rgb_multiplier:1 alpha:1 gamma_correction:0 gamma_value:2.2
		local comp = CompositeTexturemap mapList:#(vrComp,vrClr111) layerName:#("vrComp", "vrClr111") blendMode:#(0,1)
		local ccmap = Color_Correction name:("VD_Map_#"+activeMeditSlot as string) rewireMode:3 rewireR:0 rewireG:2 rewireB:1 map:comp
		meditMaterials[slot] = ccmap
	)
	dotnetControl bnr1 "Label" pos:[4,4] width:153 height:24
	dotnetControl bnr2 "Label" pos:[157,4] width:38 height:24
	group "Read Before Start :"
	(
		button btn_help "Preparation Description" pos:[8,50] width:184
	)
	pickbutton pbtn_obj "Pick Object" pos:[4,80] width:170 filter:filtObj
	button btn_clearobj "X" pos:[176,80] width:20
	group "Displacement Types :"
	(
		label lbl_dtype "Type :" pos:[8,125]
		dropdownlist ddl_disp "" pos:[42,123] width:150 items:#("Displace","VRay Displacement","Vector Displacement")
	)
	group "Get Min / Max Pixel Values :"
	(
		checkbox cb_ams "Active Material Slot" pos:[8,178] width:112 checked:on
		spinner spn_slot "" pos:[120,178] range:[1,24,1] type:#integer fieldwidth:60 enabled:off
		checkbox cb_amc "Actual Map Channel" pos:[8,198] width:112 checked:on
		spinner spn_chn "" pos:[120,198] range:[1,99,1] type:#integer fieldwidth:60 enabled:off
		spinner spn_min "Pixel Min Value :           " pos:[10,218] range:[-1e9,1e9,0] type:#float fieldwidth:60
		spinner spn_max "Pixel Max Value :          " pos:[9,238] range:[-1e9,1e9,0] type:#float fieldwidth:60
		checkbutton btn_calc "Calculate Values" pos:[8,258] width:184 highlightColor:[150,10,10]
	)
	group "TurboSmooth Settings :"
	(
		checkbox cb_ts "Use TurboSmooth Modifier" pos:[8,308] checked:on
		spinner spn_view "View Iterations :          " pos:[10,328] range:[0,1e2,5] type:#integer fieldwidth:60
		spinner spn_rnd "Render Iterations :      " pos:[9,348] range:[0,1e2,0] type:#integer fieldwidth:60
	)
	button btn_do " DO THE JOB " pos:[4,373] width:192 height:22

	fn optionBox =
	(
		try(destroyDialog ::dmoRoll)catch()
		rollout dmoRoll "Prepare Object"
		(
			local obj = selection[1]
			
			local msg = " Object have assigned modifier(s).\n This tool require clean mesh object.\n Pick one of the options below"
			label lbl_msg msg pos:[5,5] width:180 height:42 style_sunkenedge:on
			radiobuttons rb "Options:" pos:[70,48] labels:#("Collaps All Modifiers", "Remove All Modifiers", "Do It Manually")
			button btn_run "OK" pos:[5,50] width:60 height:56
			on btn_run pressed do
			(
				if obj == undefined then (destroyDialog dmoRoll) else
				(
					case rb.state of
					(
						1: (displaceMgr.dspl_obj = convertToPoly obj ; displaceMgr.pbtn_obj.text = obj.name ; destroyDialog dmoRoll)
						2: 
						(
							with redraw off (for m = obj.modifiers.count to 1 by-1 do deleteModifier obj m)
							displaceMgr.dspl_obj = (if isKindOf obj Editable_mesh then convertToPoly obj else obj)
							displaceMgr.pbtn_obj.text = obj.name ; destroyDialog dmoRoll
						)
						3: (displaceMgr.dspl_obj = undefined ; displaceMgr.pbtn_obj.text = "Pick Object" ; destroyDialog dmoRoll)
					)
				)
			)
		)
		createDialog dmoRoll 190 110 style:#(#style_titlebar, #style_sysmenu, #style_toolwindow)
	)
	fn openDescription =
	(
		try(destroyDialog ::dmdRoll)catch()
		rollout dmdRoll "Prepare Object"
		(
			local BC1 = (mngUI.defColor 0 0 0), BC2 = (mngUI.defColor 50 50 50), FC1 = (mngUI.defColor 180 180 180)
			local dmTxt = "[1] Set Target and Source Models (low && high subD level)\n[2]Check *Smooth Target Models*\n[3]Unheck *Smooth Target UVs*\r
[4]Check *Use Creases && Hard Edges*\n[5]Check *Smooth Source Models*\n[6]Use *Ray Cast* method\n[7]Use *Closest To LowRes Mesh* samples\n[8] Check *Test Both Sides*\r
[9]Use *Generate one map for all targets*\n[10]Set image size to 2K or above\n[11]Set *Antialiasing* to Off\n[12]Uncheck *Normalize To Search Distance*\r
[13]Set *Texture* for image type\n[14]Use *.exr file extension\n[15]Set bit per channel to 32 bit FP"
			local vdmTxt = "[1] Set Target and Source Models (low && high subD level)\n[2]Check *Smooth Target Models*\n[3]Unheck *Smooth Target UVs*\r
[4]Check *Use Creases && Hard Edges*\n[5]Unheck *Smooth Source Models*\n[6]Use *Generate one map for all targets*\n[7]Set image size to 2K or above\n[8]Set *Antialiasing* to Off\r
[9]Use *Relative Tangent* for vector space\n[10]Set *Texture* for image type\n[11]Use *.exr file extension\n[12]Set bit per channel to 32 bit FP"
			local tomTxt = "Import LowRes mesh (*.obj file exported from Mudbox).\nIn *OBJ Import Options* dialog make sure that\n*Retriangulate Poligons* option is unchecked.\r
Optionally you choose *Mudbox* preset and check\n*Import as Editable Poly* option"
			local tomeTxt = "Open Material Editor, pick empty slot, press *Get Matrial*\nbutton and choose *Bitmap* map.\nWhen*Select Bitmap Image File* is opened in *Gamma*\r
group check *Override* with value of 1.0.\nSelect *.exr map and in *OpenEXR configuration* dialog\nuncheck option *Enable Color Correction*."

			dotnetControl _lbl1 "Label" pos:[2,2] width:296 height:14
			dotnetControl _lbl2 "Label" pos:[2,17] width:296 height:14
			dotnetControl _lbl2a "Label" pos:[2,32] width:296 height:200
			dotnetControl _lbl3 "Label" pos:[2,233] width:296 height:14
			dotnetControl _lbl3a "Label" pos:[2,248] width:296 height:160
			dotnetControl _lbl4 "Label" pos:[2,409] width:296 height:14
			dotnetControl _lbl4a "Label" pos:[2,424] width:296 height:70
			dotnetControl _lbl5 "Label" pos:[2,495] width:296 height:14
			dotnetControl _lbl5a "Label" pos:[2,510] width:296 height:88
			on dmdRoll open do
			(
				mngUI.defLabel _lbl1 txt:"Extract Maps From Mudbox" bc:BC1 fc:FC1
				mngUI.defLabel _lbl2 txt:"  >  Displacement Map" bc:BC2 fc:FC1
				mngUI.defLabel _lbl2a txt:dmTxt bc:FC1 fc:BC2
				mngUI.defLabel _lbl3 txt:"  >  Vector Displacement Map" bc:BC2 fc:FC1
				mngUI.defLabel _lbl3a txt:vdmTxt bc:FC1 fc:BC2
				mngUI.defLabel _lbl4 txt:"Import LowRes Mesh in 3dsmax" bc:BC1 fc:FC1
				mngUI.defLabel _lbl4a txt:tomTxt bc:FC1 fc:BC2
				mngUI.defLabel _lbl5 txt:"Load Extracted Map in Material Editor" bc:BC1 fc:FC1
				mngUI.defLabel _lbl5a txt:tomeTxt bc:FC1 fc:BC2
			)
		)
		createDialog dmdRoll 300 600 style:#(#style_titlebar, #style_sysmenu, #style_toolwindow)
	)	
	on btn_help pressed do (openDescription())
	on pbtn_obj picked obj do
	(
		if obj == undefined then (dspl_obj = undefined ; pbtn_obj.text = "Pick Object") else
		(
			if obj.modifiers.count > 0 then (select obj ; optionBox()j) else 
			(
				dspl_obj = if isKindOf obj Editable_mesh then convertToPoly obj else obj
				pbtn_obj.text = obj.name
			)
		)
	)
	on btn_clearobj pressed do (dspl_obj = undefined ; pbtn_obj.text = "Pick Object")
	on ddl_disp selected itm do
	(
		displaceMgr.spn_view.value = if itm == 1 then 5 else 1
		displaceMgr.spn_rnd.value = if itm == 1 then 0 else 3
		#(spn_min,spn_max,btn_calc).enabled = if itm == 3 then false else true
	)
	on cb_ams changed state do spn_slot.enabled = not state
	on cb_amc changed state do spn_chn.enabled = not state
	on cb_ts changed state do (#(spn_view,spn_rnd).enabled = state)
	on btn_calc changed state do
	(
		if state do
		(
			local ams = if cb_ams.checked then meditMaterials[activeMeditSlot] else meditMaterials[spn_slot.value]
			if not (filtBmp ams) then (messageBox "MEdit Slot must have assigned Bitmap Texture only" title:"Warning" beep:off) else
			(
				local minmaxVals = getPxValue ams.bitmap
				spn_min.value = minmaxVals.x ; spn_max.value = minmaxVals.y
			)
			btn_calc.checked = off
		)
	)
	on btn_do pressed do
	(
		if (obj = getNodeByName pbtn_obj.text) == undefined then messageBox "Pick Mesh First!!" title:"Warning" beep:off else
		(
			local mes = 1
			if getCommandPanelTaskMode() != #create do setCommandPanelTaskMode #create
			if obj.modifiers.count != 0 do (with redraw off (for m = obj.modifiers.count to 1 by-1 do deleteModifier obj m))
			local ams = if cb_ams.checked then meditMaterials[mes=activeMeditSlot] else meditMaterials[mes=spn_slot.value]
			if isKindOf obj Editable_mesh then convertToPoly obj else if not (isKindOf obj Editable_Poly) do addModifier obj (Edit_Poly())
			local openEdge = (polyop.getOpenEdges obj).isEmpty
			if not (filtBmp ams) then (messageBox "Select MEdit Slot With Assigned Bitmap Texture Only.\nBe Sure To Calculate Pixel Value Also." title:"Warning" beep:off) else
			(
				local mapCnl = if cb_amc.checked then (ams.coords.mapChannel) else spn_chn.value
				breakUnwraper obj mapChannel:mapCnl
				if cb_ts.checked do (addModifier obj (TurboSmooth iterations:spn_view.value useRenderIterations:(if spn_rnd.value != 0 then on else off) renderIterations:spn_rnd.value isolineDisplay:on))
				case ddl_disp.selection of
				(
					1: (ams.filtering = 0 ; addModifier obj (Displace useMap:on strength:1 decay:0 Map_Channel:mapCnl map:ams))
					2: (
						if setRenderer "V_Ray_Adv*" then
						(
							ams.filtering = 2
							addModifier obj (VRayDisplacementMod type:1 texmap:ams texmapChannel:mapCnl filterMap:on filterBlur:.001 amount:1 shift:0 waterLevelOn:off relativeToBBox:off \
							EDGELENGTH:3 viewDependent:on maxSubdivs:256 smoothUVs:off smoothUVsAtBorders:openEdge tightBounds3d:on useObjectMtl:off keepContinuity:on \
							edgeThresh:.05 vectorDisplacement:off splitMethod:1 texmap_min:spn_min.value texmap_max:spn_max.value)
						) 
						else messageBox "Install VRay Renderer First!" title:"Warning" beep:off
					)
					3: (
						if setRenderer "V_Ray_Adv*" then
						(
							ams.filtering = 0 
							addModifier obj (VRayDisplacementMod type:1 texmap:(makeVDMap ams slot:mes) texmapChannel:mapCnl filterMap:on filterBlur:.001 amount:(units.decodeValue "1.0m") shift:(-(units.decodeValue "1.0m")/2) waterLevelOn:off relativeToBBox:off \
							EDGELENGTH:1 viewDependent:on maxSubdivs:256 smoothUVs:off smoothUVsAtBorders:openEdge tightBounds3d:on useObjectMtl:off keepContinuity:on \
							edgeThresh:.05 vectorDisplacement:on splitMethod:1 texmap_min:0 texmap_max:1)						
						) 
						else messageBox "Install VRay Renderer First!" title:"Warning" beep:off	
					)
				)
			)
		)
	)	
	on displaceMgr open do
	(
		mngUI.defLabel bnr1 txt:"displace" bc:(mngUI.defColor 0 0 0) fc:(mngUI.defColor 235 235 235) align:#right size:10
		mngUI.defLabel bnr2 txt:"Mgr" bc:(mngUI.defColor 235 235 235) fc:(mngUI.defColor 150 10 10) size:10
	)
)
createDialog displaceMgr 200 400 style:#(#style_titlebar, #style_sysmenu, #style_toolwindow)
clearListener()